clc;clear;
%%%%%%%%%%%Parameters Are HERE!!!!!!!!!
P=0.001;   %possibility that an infected person get another
P_Recover=0.001;    %possibility of recovering
Avr_Con_Num=14;    %average of connections of one person
Infected_Num=2;    %the infected people number when start
People_Num=140;  %Total number of people(sample)
%%%%%%%%%%%Parameters Done!!!!!!!!
Log_People_Num = ceil(log2(People_Num));
char16='0123456789ABCDEF';
Ptemp=P;
P_Recovertemp=P_Recover;
charP=[];
charP_Recover=[];
InitInfected=zeros(People_Num,1);
Individual=zeros(People_Num,2);  %graph, including Num of people and their connections
Col_Num_Max=2;
for i=1:1:People_Num             %build graph(connections)
    Individual(i,1)=i;
end
for Relation=1:1:People_Num*Avr_Con_Num/2  %build relation
    flag=0;
    while (flag==0)
        temp1=ceil(rand()*People_Num);
        temp2=ceil(rand()*People_Num);
        if (temp1~=temp2)
            for i=2:1:Col_Num_Max
                if Individual(temp1,i)==temp2
                    break;  %if reduplicate, break for
                elseif Individual(temp1,i)==0  %valid relation
                    Individual(temp1,i)=temp2;
                    for j=2:1:Col_Num_Max %non-direction link
                        if Individual(temp2,j)==0
                            Individual(temp2,j)=temp1;
                            flag=1;
                            break;
                        elseif j==Col_Num_Max
                            Individual=[Individual,zeros(People_Num,1)];
                            Col_Num_Max=Col_Num_Max+1;
                            Individual(temp2,j+1)=temp1;
                            flag=1;
                            break;
                        end
                    end
                    break;
                elseif i==Col_Num_Max
                    Individual=[Individual,zeros(People_Num,1)];
                    Col_Num_Max=Col_Num_Max+1;
                end
            end
        end
    end
end

Individual = [Individual,zeros(People_Num,1)];  % add a colomn of zeroat the end

for i=1:1:4       %create 16_bit char for Probability
    Ptemp=Ptemp*16;
    charP=[charP,char16(floor(Ptemp)+1)];
    Ptemp=Ptemp-floor(Ptemp);
    P_Recovertemp=P_Recovertemp*16;
    charP_Recover=[charP_Recover,char16(floor(P_Recovertemp)+1)];
    P_Recovertemp=P_Recovertemp-floor(P_Recovertemp);
end
i=1;
while i<=Infected_Num
    getInf=ceil(People_Num*rand());
    if InitInfected(getInf,1)==0
        InitInfected(getInf,1)=1;
        i=i+1;
    end
end
fid=fopen('SIR.v','wt');
fid_simu = fopen('simu.txt','wt');
%---------------------------------------------------
% print relation in the txt file
%---------------------------------------------------
for i=1:1:People_Num
    j=1;
    while (Individual(i,j)~=0)
        fprintf(fid_simu,'%i ',Individual(i,j));
        j=j+1;
    end
    if (InitInfected(i,1) == 0)
        fprintf(fid_simu,'0\n');
    else
        fprintf(fid_simu,'-1\n');
    end
end
%---------------------------------------------------
%module SIR(clk,Reset_All,Reset_I,S,I);
%---------------------------------------------------
fprintf(fid,'module SIR(clk,Reset_All,Reset_I,S,I);\n');
fprintf(fid,'\tinput wire clk,Reset_All,Reset_I;\n');
fprintf(fid,'\toutput wire [%i:1]S;\n',People_Num);
fprintf(fid,'\toutput wire [%i:1]I;\n',People_Num);
fprintf(fid,'\twire Reset = Reset_All | Reset_I;\n');
fprintf(fid,'\twire state_in;\n');
fprintf(fid,'\tassign state_in=0;\n');
fprintf(fid,'\twire [15:0]Constin_en;\n');
fprintf(fid,'\twire [15:0]Constin_dis;\n');
fprintf(fid,'\tassign Constin_en=15''h%s;\n',charP);
fprintf(fid,'\tassign Constin_dis=15''h%s;\n',charP_Recover);

for i=1:1:People_Num
    fprintf(fid,'\twire en%i;\n',i);
    fprintf(fid,'\twire result_dis%i;\n',i);
    fprintf(fid,'\twire [63:1]seed_dis%i;\n',i);
    fprintf(fid,'\twire [15:0]rand_dis%i;\n',i);
    if InitInfected(i,1)==0
        fprintf(fid,'\tSIR_cell SIR%i (clk, en%i, result_dis%i, Reset, S [%i], I[%i]);\n',i,i,i,i,i);
    else
        fprintf(fid,'\tSIR_cell SIR%i (clk, 1, result_dis%i, Reset, S [%i], I[%i]);\n',i,i,i,i);
    end
    fprintf(fid,'\trand63 rand63_dis%i(.rand_out(rand_dis%i), .seed_in(seed_dis%i), .state_in(state_in), .clock_in(clk), .reset_in(Reset_All));\n',i,i,i);
    fprintf(fid,'\tComparator compdis%i(.clk(clk),.rst(Reset),.Constin(Constin_dis),.Variablein(rand_dis%i),.en(I[%i]),.Result(result_dis%i));\n',i,i,i,i);
    fprintf(fid,'\tassign seed_dis%i=63''h',i);
    temp_char = char16(ceil(rand()*8));
    fprintf(fid,'%c',temp_char);
    fprintf(fid_simu,'%c',temp_char);
    for j=1:1:15    %assign seeds
        temp_char = char16(ceil(rand()*16));
        fprintf(fid,'%c',temp_char);
        fprintf(fid_simu,'%c',temp_char);
    end
    fprintf(fid_simu,'\n');
    fprintf(fid,';\n');
    for j=2:1:Col_Num_Max
        target = Individual(i,j);
        if target == 0
            break;
        end
        fprintf(fid,'\twire result_en%i_to_%i;\n',i,target);
        fprintf(fid,'\twire [63:1]seed_en%i_to_%i;\n',i,target);
        fprintf(fid,'\twire [15:0]rand_en%i_to_%i;\n',i,target);
        fprintf(fid,'\tassign seed_en%i_to_%i=63''h',i,target);
        temp_char = char16(ceil(rand()*8));
        fprintf(fid,'%c',temp_char);
        fprintf(fid_simu,'%c',temp_char);
        for k=1:1:15    %assign seeds
            temp_char = char16(ceil(rand()*16));
            fprintf(fid,'%c',temp_char);
            fprintf(fid_simu,'%c',temp_char);
        end
        fprintf(fid_simu,'\n');
        fprintf(fid,';\n\trand63 rand63_en%i_to_%i(.rand_out(rand_en%i_to_%i), .seed_in(seed_en%i_to_%i), .state_in(state_in), .clock_in(clk), .reset_in(Reset_All));\n',i,target,i,target,i,target);
        fprintf(fid,'\tComparator compen%i_to_%i(.clk(clk),.rst(Reset),.Constin(Constin_en),.Variablein(rand_en%i_to_%i),.en(I[%i]),.Result(result_en%i_to_%i));\n',i,target,i,target,i,i,target);
    end

end
%---------------------------------------------------
% Relations
%---------------------------------------------------
for i=1:1:People_Num    %relation
    fprintf(fid,'\tassign en%i=1''b0',i);
    j=2;
    while j<=Col_Num_Max && Individual(i,j)~=0
        fprintf(fid,' | result_en%i_to_%i',Individual(i,j),i);
        j=j+1;
    end
    fprintf(fid,';\n');
end
fprintf(fid,'endmodule\n');
%---------------------------------------------------
% module SIR_cell(clk, StoIEn, ItoREn, Reset, S, I);
%---------------------------------------------------
fprintf(fid,'module SIR_cell (clk, StoIEn, ItoREn, Reset, S, I);\n');
fprintf(fid,'\toutput reg S,I;\n');
fprintf(fid,'\tinput wire clk,StoIEn,ItoREn,Reset;\n');
fprintf(fid,'\talways @ (posedge clk)\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\tif (Reset)\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tS<=1''b1;\n');
fprintf(fid,'\t\t\tI<=1''b0;\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\t\telse\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tif (StoIEn && S)\n');
fprintf(fid,'\t\t\tbegin\n');
fprintf(fid,'\t\t\t\tS<=1''b0;\n');
fprintf(fid,'\t\t\t\tI<=1''b1;\n');
fprintf(fid,'\t\t\tend\n');
fprintf(fid,'\t\t\tif (ItoREn && I)\n');
fprintf(fid,'\t\t\tbegin\n');
fprintf(fid,'\t\t\t\tI<=1''b0;\n');
fprintf(fid,'\t\t\tend\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\tend\n');
fprintf(fid,'endmodule\n');
%---------------------------------------------------
%module Comparator (clk,rst,Constin,Variablein,en,Result);
%---------------------------------------------------
fprintf(fid,'module Comparator (clk,rst,Constin,Variablein,en,Result);\n');
fprintf(fid,'\tinput wire [15:0] Variablein;\n');
fprintf(fid,'\tinput wire [15:0] Constin;\n');
fprintf(fid,'\tinput wire clk,rst,en;\n');
fprintf(fid,'\toutput reg Result;\n');
fprintf(fid,'\treg [1:0]state;\n');
fprintf(fid,'\treg tempResult;\n');
fprintf(fid,'\talways @ (posedge clk)\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\tif (rst)\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tstate<=2''b00;\n');
fprintf(fid,'\t\t\tResult<=1''b0;\n');
fprintf(fid,'\t\t\ttempResult<=1''b0;\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\t\telse\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tcase (state)\n');
fprintf(fid,'\t\t\t2''b00:\n');
fprintf(fid,'\t\t\t\tbegin\n');
fprintf(fid,'\t\t\t\t\tResult <= (en && Variablein<Constin);\n');
fprintf(fid,'\t\t\t\tend\n');
fprintf(fid,'\t\t\tendcase\n');
fprintf(fid,'\t\t\tstate <= state + 1''b1;\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\tend\n');
fprintf(fid,'endmodule\n');
%---------------------------------------------------
%module rand63(rand_out, seed_in, state_in, clock_in, reset_in);
%---------------------------------------------------
fprintf(fid,'module rand63(rand_out, seed_in, state_in, clock_in, reset_in);\n');
fprintf(fid,'\toutput wire [15:0] rand_out ;\n');
fprintf(fid,'\tinput wire state_in ;\n');
fprintf(fid,'\tinput wire clock_in, reset_in ;\n');
fprintf(fid,'\tinput wire [63:1] seed_in; \n');
fprintf(fid,'\treg [4:1] sr1, sr2, sr3, sr4, sr5, sr6, sr7, sr8, sr9, sr10, sr11, sr12, sr13, sr14, sr15, sr16;\n');
fprintf(fid,'\tparameter react_start=1''b0 ;\n');
fprintf(fid,'\tassign rand_out = {sr1[3], sr2[3], sr3[3], sr4[3],sr5[3], sr6[3], sr7[3], sr8[3],sr9[3], sr10[3], sr11[3], sr12[3],sr13[3], sr14[3], sr15[3], sr16[3]} ;\n');
fprintf(fid,'\talways @ (posedge clock_in)\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\tif (reset_in)\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tsr1 <= seed_in[4:1] ;\n');
fprintf(fid,'\t\t\tsr2 <= seed_in[8:5] ;\n');
fprintf(fid,'\t\t\tsr3 <= seed_in[12:9] ;\n');
fprintf(fid,'\t\t\tsr4 <= seed_in[16:13] ;\n');
fprintf(fid,'\t\t\tsr5 <= seed_in[20:17] ;\n');
fprintf(fid,'\t\t\tsr6 <= seed_in[24:21] ;\n');
fprintf(fid,'\t\t\tsr7 <= seed_in[28:25] ;\n');
fprintf(fid,'\t\t\tsr8 <= seed_in[32:29] ;\n');
fprintf(fid,'\t\t\tsr9 <= seed_in[36:33] ;\n');
fprintf(fid,'\t\t\tsr10 <= seed_in[40:37] ;\n');
fprintf(fid,'\t\t\tsr11 <= seed_in[44:41] ;\n');
fprintf(fid,'\t\t\tsr12 <= seed_in[48:45] ;\n');
fprintf(fid,'\t\t\tsr13 <= seed_in[52:49] ;\n');
fprintf(fid,'\t\t\tsr14 <= seed_in[56:53] ;\n');
fprintf(fid,'\t\t\tsr15 <= seed_in[60:57] ;\n');
fprintf(fid,'\t\t\tsr16 <= {1''b0,seed_in[63:61]} ;\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\t\telse\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tsr1 <= {sr1[3:1], sr16[3]^sr15[3]} ;\n');
fprintf(fid,'\t\t\tsr2 <= {sr2[3:1], sr16[3]^sr1[4]}  ;\n');
fprintf(fid,'\t\t\tsr3 <= {sr3[3:1], sr1[4]^sr2[4]}  ;\n');
fprintf(fid,'\t\t\tsr4 <= {sr4[3:1], sr2[4]^sr3[4]}  ;\n');
fprintf(fid,'\t\t\tsr5 <= {sr5[3:1], sr3[4]^sr4[4]}  ;\n');
fprintf(fid,'\t\t\tsr6 <= {sr6[3:1], sr4[4]^sr5[4]}  ;\n');
fprintf(fid,'\t\t\tsr7 <= {sr7[3:1], sr5[4]^sr6[4]}  ;\n');
fprintf(fid,'\t\t\tsr8 <= {sr8[3:1], sr6[4]^sr7[4]}  ;\n');
fprintf(fid,'\t\t\tsr9 <= {sr9[3:1], sr7[4]^sr8[4]}  ;\n');
fprintf(fid,'\t\t\tsr10 <= {sr10[3:1], sr8[4]^sr9[4]}  ;\n');
fprintf(fid,'\t\t\tsr11 <= {sr11[3:1], sr9[4]^sr10[4]}  ;\n');
fprintf(fid,'\t\t\tsr12 <= {sr12[3:1], sr10[4]^sr11[4]}  ;\n');
fprintf(fid,'\t\t\tsr13 <= {sr13[3:1], sr11[4]^sr12[4]}  ;\n');
fprintf(fid,'\t\t\tsr14 <= {sr14[3:1], sr12[4]^sr13[4]}  ;\n');
fprintf(fid,'\t\t\tsr15 <= {sr15[3:1], sr13[4]^sr14[4]}  ;\n');
fprintf(fid,'\t\t\tsr16 <= {sr16[3:1], sr14[4]^sr15[4]}  ;\n');
fprintf(fid,'\t\tend\n');
fprintf(fid,'\tend\n');
fprintf(fid,'endmodule\n');
%---------------------------------------------------
%module Infected_Adder_Tree(clk,rst,I,sumI)
%---------------------------------------------------
Adder_Tree = [];
Adder_Num = ceil(People_Num/2);
Tree_Depth = 0;
while (Adder_Num>1)
    Adder_Tree = [Adder_Tree,Adder_Num];
    Adder_Num = ceil(Adder_Num/2);
    Tree_Depth = Tree_Depth + 1;
end
fprintf(fid,'module Infected_Adder_Tree(clk,rst,I,sumI);\n');
fprintf(fid,'\tinput clk,rst;\n');
fprintf(fid,'\tinput [%i:1]I;\n',People_Num);
fprintf(fid,'\toutput wire [%i:0]sumI;\n',Log_People_Num);
fprintf(fid,'\twire [%i:0]sumI_temp;\n',Log_People_Num);
fprintf(fid,'\treg [%i:0]sumI_r;\n',Log_People_Num);
fprintf(fid,'\treg [%i:1]Itemp;\n',People_Num);
fprintf(fid,'\tassign sumI = sumI_r;\n');
for i = 1:1:Tree_Depth
    for j = 1:1:Adder_Tree(i)
        fprintf(fid,'\treg [%i:0]adder_%i_%i;\n',i,i,j);
    end
end
if (Tree_Depth ~= 0)
    fprintf(fid,'\tassign sumI_temp = adder_%i_1 + adder_%i_2;\n',Tree_Depth,Tree_Depth);
else
    fprintf(fid,'\tassign sumI_temp = Itemp;\n');
end
fprintf(fid,'\talways @ (posedge clk)\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\tItemp[%i:1]<=I[%i:1];\n',People_Num,People_Num);
for i = 1:1:Tree_Depth
    for j = 1:1:Adder_Tree(i)
        if (i==1)       %%First line
            if (2*j<=People_Num)
                fprintf(fid,'\t\tadder_%i_%i <= Itemp[%i]+Itemp[%i];\n',i,j,(2*j-1),2*j);
            else
                fprintf(fid,'\t\tadder_%i_%i <= Itemp[%i];\n',i,j,(2*j-1));
            end
        else
            if (2*j<=Adder_Tree(i-1))
                fprintf(fid,'\t\tadder_%i_%i <= adder_%i_%i+adder_%i_%i;\n',i,j,i-1,(2*j-1),i-1,2*j);
            else
                fprintf(fid,'\t\tadder_%i_%i <= adder_%i_%i;\n',i,j,i-1,(2*j-1));
            end
        end
    end
end
fprintf(fid,'\t\tsumI_r <= sumI_temp;\n');
fprintf(fid,'\tend\n');

fprintf(fid,'endmodule\n');
%---------------------------------------------------
%module VGA_DISPLAY(VGA_CAL_CLK,VGA_RST,Coord_X,Coord_Y,WriteAddrX,WriteAddrY,WriteInBits,sumI,IsReadFlag)
%---------------------------------------------------
fprintf(fid,'module VGA_DISPLAY(VGA_CAL_CLK,VGA_RST,Coord_X,Coord_Y,WriteAddrX,WriteAddrY,WriteInBits,sumI,IsReadFlag,counter_fix);\n');
fprintf(fid,'\tinput VGA_CAL_CLK;\n');
fprintf(fid,'\tinput VGA_RST;\n');
fprintf(fid,'\tinput [9:0]Coord_X;\n');
fprintf(fid,'\tinput [8:0]Coord_Y;\n');
fprintf(fid,'\toutput reg [9:0]WriteAddrX;\n');
fprintf(fid,'\toutput reg [8:0]WriteAddrY;\n');
fprintf(fid,'\toutput reg [15:0]WriteInBits;\n');
fprintf(fid,'\toutput reg IsReadFlag;\n');
fprintf(fid,'\tinput [10:0]sumI;\n');
fprintf(fid,'\tinput [7:0]counter_fix;\n');
fprintf(fid,'\treg Start;\n');
fprintf(fid,'\treg [7:0]counter;\n');
fprintf(fid,'\talways @ (posedge VGA_CAL_CLK or posedge VGA_RST)\n');
fprintf(fid,'\tbegin\n');

fprintf(fid,'\t\tif (VGA_RST)\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tIsReadFlag<=1''b0;\n');
fprintf(fid,'\t\t\tWriteAddrX<=Coord_X[9:0];\n');
fprintf(fid,'\t\t\tWriteAddrY<=Coord_Y[8:0];\n');
fprintf(fid,'\t\t\tWriteInBits<=16''h0000;\n');
fprintf(fid,'\t\t\tStart<=1''b0;\n');
fprintf(fid,'\t\t\tcounter<=8''b0;\n');
fprintf(fid,'\t\tend\n');

fprintf(fid,'\t\telse\n');
fprintf(fid,'\t\tbegin\n');
fprintf(fid,'\t\t\tif (counter >= counter_fix)\n');
fprintf(fid,'\t\t\tbegin\n');
fprintf(fid,'\t\t\t\tif (Start==1''b0)\n');
fprintf(fid,'\t\t\t\tbegin\n');
fprintf(fid,'\t\t\t\t\tStart<=1''b1;\n');
fprintf(fid,'\t\t\t\t\tWriteAddrX<=10''b0;\n');
fprintf(fid,'\t\t\t\t\tWriteAddrY<=9''d479-{sumI,2''b0};\n');
fprintf(fid,'\t\t\t\t\tWriteInBits <= 16''hFF00;\n');
fprintf(fid,'\t\t\t\tend\n');
fprintf(fid,'\t\t\t\telse if (WriteAddrX>=10''d639)\n');
fprintf(fid,'\t\t\t\tbegin\n');
fprintf(fid,'\t\t\t\t\tIsReadFlag<=1''b1;\n');
fprintf(fid,'\t\t\t\tend\n');
fprintf(fid,'\t\t\t\telse if (WriteAddrX[0]==1''b0)\n');
fprintf(fid,'\t\t\t\tbegin\n');
fprintf(fid,'\t\t\t\t\tWriteAddrX<=WriteAddrX+1;\n');
fprintf(fid,'\t\t\t\t\tWriteAddrY<=9''d479-{sumI,2''b0};\n');
fprintf(fid,'\t\t\t\t\tWriteInBits <= (WriteAddrY==9''d479-{sumI,2''b0})? 16''hFFFF : 16''hFF00;\n');
fprintf(fid,'\t\t\t\tend\n');
fprintf(fid,'\t\t\t\telse\n');
fprintf(fid,'\t\t\t\tbegin\n');
fprintf(fid,'\t\t\t\t\tWriteAddrX<=WriteAddrX+1;\n');
fprintf(fid,'\t\t\t\t\tWriteAddrY<=9''d479-{sumI,2''b0};\n');
fprintf(fid,'\t\t\t\t\tWriteInBits <= 16''h00FF;\n');
fprintf(fid,'\t\t\t\tend\n');
fprintf(fid,'\t\t\t\tcounter <= 8''b0;\n');
fprintf(fid,'\t\t\tend\n');
fprintf(fid,'\t\t\telse\n');
fprintf(fid,'\t\t\tbegin\n');
fprintf(fid,'\t\t\t\tcounter <= counter + 1''b1;\n');
fprintf(fid,'\t\t\tend\n');
fprintf(fid,'\t\tend\n');

fprintf(fid,'\tend\n');
fprintf(fid,'endmodule');

fclose(fid);
fclose(fid_simu);
%---------------------------------------------------
%SIRTest.v
%---------------------------------------------------
fid=fopen('SIRTest.v','wt');
fprintf(fid,'`timescale 1ns/1ns\n');
fprintf(fid,'`include "SIR.v"\n');
fprintf(fid,'module SIRTest;\n');
fprintf(fid,'\treg clk,rst;\n');
fprintf(fid,'\twire [%i:1]S;\n',People_Num);
fprintf(fid,'\twire [%i:1]I;\n',People_Num);
fprintf(fid,'\tSIR SIR1(.clk(clk),.Reset(rst),.S(S),.I(I));\n');
fprintf(fid,'\talways\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\t#10 clk=~clk;\n');
fprintf(fid,'\tend\n');
fprintf(fid,'\tinitial\n');
fprintf(fid,'\tbegin\n');
fprintf(fid,'\t\tclk=1''b0;\n');
fprintf(fid,'\t\t#5 rst=1''b1;\n');
fprintf(fid,'\t\t#10 rst=1''b0;\n');
fprintf(fid,'\tend\n');
fprintf(fid,'endmodule\n');
fclose(fid);