%MATLAB code of Stochastic Algorithm
%tg293
%version0.2 9/16/2012

clc;clear;
%%%%%%%%%%%Parameters Are HERE!!!!!!!!!
P=0.0005;   %possibility that an infected person get another
P_Recover=0.0005;    %possibility of recovering
Avr_Con_Num=12;    %average of connections of one person
Infected_Num=2;    %the infected people number when start
People_Num = 130;  %Total number of people(sample)
run_times = 20;
%%%%%%%%%%%Parameters Done!!!!!!!!

execution_time = 0;
cycle_num = 0;
e_array = [];
c_array = [];
for times = 1:1:run_times

flag=0;     %is it stable
Poisson = poissrnd(Avr_Con_Num, People_Num, 1);  % generate everyone's connections number
Con_Num_Max=2;

%plot(t,Poisson);
Loc=zeros(People_Num,2);

Individual=zeros(People_Num,2);  %graph, including Num of people and their connections

InitInfected=zeros(People_Num,1); % judge if it's initially infected

State=ones(People_Num,2); %col 1 is now, col 2 is next step, 1 stands for s,2 for i 3 for r
for i=1:1:People_Num             %build graph(connections)
    Individual(i,1)=i;
    Loc(i,1)=rand();     % give each individual a location
    Loc(i,2)=rand();
end
for Relation=1:1:People_Num*Avr_Con_Num/2  %build relation
    flag=0;
    while (flag==0)
        temp1=ceil(rand()*People_Num);
        temp2=ceil(rand()*People_Num);
        if (temp1~=temp2)
            for i=2:1:Con_Num_Max
                if Individual(temp1,i)==temp2
                    break;  %if reduplicate, break for
                elseif Individual(temp1,i)==0  %valid relation
                    Individual(temp1,i)=temp2;
                    for j=2:1:Con_Num_Max %non-direction link
                        if Individual(temp2,j)==0
                            Individual(temp2,j)=temp1;
                            flag=1;
                            break;
                        elseif j==Con_Num_Max
                            Individual=[Individual,zeros(People_Num,1)];
                            Con_Num_Max=Con_Num_Max+1;
                            Individual(temp2,j+1)=temp1;
                            flag=1;
                            break;
                        end
                    end
                    break;
                elseif i==Con_Num_Max
                    Individual=[Individual,zeros(People_Num,1)];
                    Con_Num_Max=Con_Num_Max+1;
                end
            end
        end
    end
end
i=1;
while i<=Infected_Num
    getInf=ceil(People_Num*rand());
    if InitInfected(getInf,1)==0
        InitInfected(getInf,1)=1;
        State(getInf,1)=2;
        i=i+1;
    end
end
Step_Num=0;   %count step number
flag=0;   %infection
InfNum=0;
t = cputime;
while (flag==0)          %start INFECTION!!!
    flag=1;         %assume stable
    Step_Num=Step_Num+1;
    Calculate=zeros(1,3);
    for i=1:1:People_Num
        if State(i,1)==2 %if the sample is infected, calculate
            j=2;    %column 2 to check the connections
            if (rand()<P_Recover)   %Recover
                State(i,2)=3;
            else    %not recover
                State(i,2)=2;
            end
            while (j<=Con_Num_Max && Individual(i,j)~=0)  %check valid connections
                if (State(Individual(i,j),1)==1 && State(Individual(i,j),2)==1) %if connection s and next s
                    if (rand()<P)     %roll the dice
                        State(Individual(i,j),2)=2;
                        %fprintf('%d infected %d',i,Individual(i,j));
                    end
                end
                j=j+1;
            end
            flag=0;  %once there's one infection, unstable
        end
    end
    for i=1:1:People_Num
%         if State(i,1)==1      %plot state
%             plot(Loc(i,1),Loc(i,2),'bo');
%         elseif State(i,1)==2
%             plot(Loc(i,1),Loc(i,2),'ro','MarkerFaceColor','r');
%         else
%             plot(Loc(i,1),Loc(i,2),'go','MarkerFaceColor','g');
%         end
        j=2;
%         while (j<=Con_Num_Max && Individual(i,j)~=0)  %check valid connections
%             plot([Loc(i,1),Loc(Individual(i,j),1)],[Loc(i,2),Loc(Individual(i,j),2)]);
%             j=j+1;
%         end
        State(i,1)=State(i,2);   %update State

        Calculate(1,State(i,1))=Calculate(1,State(i,1))+1;
    end
    InfNum=[InfNum,Calculate(1,2)];
end
e = cputime-t
%figure();
plot([1:1:Step_Num+1],InfNum);
disp('finish');
disp(Step_Num);
execution_time = execution_time + e;
e_array = [e_array, e];
cycle_num = cycle_num + Step_Num;
c_array = [c_array,Step_Num];
end

execution_time = execution_time / run_times
cycle_num = cycle_num / run_times
